#version 330

uniform sampler2DRect inputTex;
uniform sampler2DRect maskTex;

layout (location=0) in vec3 vsPosition;
layout (location=1) in vec2 vsTexture;
uniform float radius;

out vec2 fsTexture;
out vec2 fsMaskTexture;
out vec3 fsPosition;
out float fsInnerRadius;
out float fsOuterRadius;

void main()
{
	gl_Position=vec4(vsPosition.x,vsPosition.y,vsPosition.z,1.0);

    fsOuterRadius=radius/100.0;
    fsInnerRadius=fsOuterRadius*.5;

    fsTexture = vsTexture;
    
    ivec2 texSize=textureSize(inputTex);
    fsPosition=vsPosition*vec3(1.0,float(texSize.y)/float(texSize.x),1.0);
    fsMaskTexture=vsTexture/vec2(texSize);
    
    texSize=textureSize(maskTex);
    fsMaskTexture*=vec2(texSize);
}
