
//#include "metalShaderTypes.h"


vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]])
{
    vertexOut out;

	out.normPos=in[vertexID].pos.xy;

	
	float stimer=0.;
	if(uniforms.transitionState==0)
	  stimer=3.1415926535897932384626433832795+uniforms.transitionProgress*3.1415926535897932384626433832795;
	else if(uniforms.transitionState==2)
	  stimer=uniforms.transitionProgress*3.1415926535897932384626433832795;

	mat4 rotation = mat4(
					   cos(stimer),  0.0,-sin(stimer), 0.0,
					   0.0,  1.0,        0.0, 0.0,
					   sin(stimer),  0.0, cos(stimer), 0.0,
					   0.0,  0.0,        0.0, 1.0);
	mat4 projection = mat4(
						 2.4140,0.0000,0.0000,0.0000,
						 0.0000,2.4140,0.0000,0.0000,
						 0.0000,0.0000,-1.020,-.4870,
						 0.0000,0.0000,-1.000,0.0000);
	mat4 translation=mat4(
						1.0, 0.0, 0.0, 0.00,
						0.0, 1.0, 0.0, 0.00,
						0.0, 0.0, 1.0,-2.41,
						0.0, 0.0, 0.0, 1.00);

	vec4 tmpPos=vec4(in[vertexID].pos.xyz,1.0)*uniforms.worldViewProj;

	vec4 worldPos=tmpPos*rotation;
	worldPos*=translation;
	out.position=worldPos*projection;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
    return out;
}

fragment float4 fragmentFunc(vertexOut in [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& u[[ buffer(2) ]])
{
	
	float4 outColor=tex(inputTex0,in.tex1);

#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,in.texMask).a);
#endif
	return outColor;
}
